# Робот мелдеши

Сегед университетинин AI(жасалма интеллект) изилдөөчүлөрү роботторду программалоо боюнча сынак өткөрүп жатышат.
Досуңуз Ханга мелдешке катышууну чечти. Максаты - атактуу венгриялык койчунун жардамчы ит тукумунун Пулидин улуу интеллектине суктанган акыркы _Pulibot_ программалоо.

_Pulibot_ $(H+2) \times (W+2)$ торчолордон турган лабиринтте сыналат.
Тордун катарлары түндүктөн түштүккө $-1$ден $H$ге чейин, ал эми тордун мамылары батыштан чыгышка чейин $-1$ден $W$ге чейин номерленген.
Тордун $r$ сабында жана $c$ тилкесинде жайгашкан клетканы ($-1 \le r \le H$, $-1 \le c \le W$) $(r, c)$ клеткасы деп атайбыз.

$0 \le r \lt H$ жана $0 \le c \lt W$ болгон $(r,c)$ клеткасын карап көрөлү. $(r,c)$ клеткасына **коңшу** $4$ клеткалары бар:
* $(r,c-1)$ клеткасы $(r,c)$ клеткасынын **батышындагы** клеткасы деп аталат;
* $(r+1,c)$ клеткасы $(r,c)$ клеткасынын **түштүгүндөгү** клеткасы деп аталат;
* $(r,c+1)$ клеткасы $(r,c)$ клеткасынын **чыгышындагы** клеткасы деп аталат;
* $(r-1,c)$ клеткасы $(r,c)$ клеткасынын **түндүгүндөгү** клеткасы деп аталат.

$r=-1$ же $r=H$ же $c=-1$ же $c=W$ орун алса, $(r,c)$ клеткасы лабиринттин **чек ара** клеткасы деп аталат.
Лабиринттин чек ара клеткасы болбогон ар бир клетка же **тоскоолдук** клетка же **бош** клетка.
Кошумчалай кетсек, ар бир бош клетканын **түсү** бар, ал $0$ жана $Z_{MAX}$ ортосундагы терс эмес бүтүн сан менен көрсөтүлгөн.
Башында, ар бир бош клетканын түсү $0 $ болуп саналат.

Мисалы, $H=4$ жана $W=5$ болгон лабиринтти карап көрөлү, анда $(1,3)$ бир тоскоолдук клеткасы бар:


![Numbering](robot-numbering.png "250")

Жалгыз тоскоолдук клеткасы крест менен белгиленген. Лабиринттин чек ара клеткалары карага боёлгон.
Ар бир бош клеткадагы сан анын түсүн билдирет.

$(r_0, c_0)$ клеткасынан $(r_\ell, c_\ell)$ клеткасына $\ell$ ($\ell \gt 0$) узундуктагы **жол**
экиден айырмаланган *бош* клеткалардын ырааттуулугу $(r_0,c_0), (r_1, c_1), \ldots, (r_\ell, c_\ell)$
ар бир $i$ ($0 \le i \lt \ell$) үчүн $(r_i, c_i)$ жана $(r_{i+1}, c_{i+1})$ клеткалары
жанаша.

$\ell$ узундуктагы жол так ($\ell+1$) клеткаларын камтыганын эске алыңыз.

Мелдеште изилдөөчүлөр $(0,0)$ клеткасынан $(H-1, W-1)$ клеткасына чейин жок дегенде бир жол бар болгон лабиринт түзүштү.
Бул $(0, 0)$ жана $(H-1, W-1)$ клеткаларынын бош болушуна кепилдик берилгенин эске алыңыз.

Ханга лабиринттин кайсы клеткалары бош, кайсы клеткалар тоскоолдуктар экенин билбейт.

Сиздин милдетиңиз Хангага _Pulibot_ту программалоого жардам берүү, ал $(0,0)$ клеткасынан $(H-1, W-1)$ клеткасына чейин *эң кыска жолду* (б.а. минималдуу узундуктагы жолду) таба алат. Изилдөөчүлөр тарабынан орнотулган белгисиз лабиринтте.
_Pulibot_тун спецификациясы жана мелдештин эрежелери төмөндө баяндалган.

Бул көйгөй билдирүүсүнүн акыркы бөлүмүндө сиз _Pulibot_ту визуалдаштыруу үчүн колдоно турган дисплей куралы сүрөттөлгөнүнө көңүл буруңуз.

### Pulibotтун спецификациясы

Ар бир $-1 \le r \le H$ жана $-1 \le c \le W$ үчүн $(r,c)$ клеткасынын **абалын** бүтүн сан катары аныктаңыз:
* эгерде $(r,c)$ клеткасы чектик клетка болсо, анда анын абалы $-2$;
* эгерде $(r,c)$ клеткасы тоскоолдук клеткасы болсо, анда анын абалы $-1$;
* эгерде $(r,c)$ клеткасы бош клетка болсо, анда анын абалы клетканын түсү болуп саналат.

_Pulibot_тун программасы кадамдардын ырааттуулугу катары аткарылат.
Ар бир кадамда _Pulibot_ коңшу жайгашкан клеткалардын абалын таанып, андан кийин көрсөтмөлөрдү аткарат.
Ал аткарган көрсөтмө таанылган абалдар тарабынан аныкталат.
Төмөндө дагы так аныктамасы келтирилген.

Учурдагы кадамдын башында _Pulibot_ $(r,c)$ клеткасында, ал бош клеткада.
Кадам төмөнкүдөй жүзөгө ашырылат:

1. Биринчиден, _Pulibot_ учурдагы **абалдардын массивин**, башкача айтканда $S = [S[0], S[1], S[2], S[3], S[4]]$ массивдерин тааныйт. $(r,c)$ клеткасынын жана бардык коңшу клеткалардын абалынан турат:
     * $S[0]$ — $(r,c)$ клеткасынын абалы.
     * $S[1]$ — батыштагы клетканын абалы.
     * $S[2]$ — түштүктөгү клетканын абалы.
     * $S[3]$ — чыгыштагы клетканын абалы.
     * $S[4]$ — түндүктөгү клетканын абалы.
1. Андан кийин, _Pulibot_ таанылган абалдардын массивине туура келген **инструкцияны** $(Z, A)$ аныктайт.
1. Акырында, _Pulibot_ бул көрсөтмөнү аткарат: $(r, c)$ клеткасынын түсүн $Z$ түсүнө өзгөртөт.
андан кийин ал $A$ аракетин аткарат, бул төмөнкү аракеттердин бири:
     * $(r,c)$ клеткасында *калуу*;
     * $4$ коңшу клеткалардын бирине *жылуу*;
     * *программаны токтотуу*.

Мисалы, төмөнкү сүрөттүн сол жагында көрсөтүлгөн сценарийди карап көрөлү.
_Pulibot_ учурда $0$ түсү менен $(0, 0)$ клеткасында.
_Pulibot_ $S = [0, -2, 2, 2, -2]$ абалдардын массивин тааныйт.
_Pulibot_то бул массивди тааныгандан кийин учурдагы клетканын түсүн $Z = 1$ кылып коюп, андан кийин чыгышка жыла турган программа болушу мүмкүн,
сүрөттүн ортосунда жана оң жагында көрсөтүлгөндөй:


![Actions of a step of Pulibot](robot-actions.png "700")

### Робот мелдешинин эрежелери

* Башында _Pulibot_ $(0,0)$ клеткасына жайгаштырылат жана өзүнүн программасын аткара баштайт.
* _Pulibot_ко бош эмес клеткага өтүүгө уруксат берилбейт.
* _Pulibot_тун программасы эң көп $500\,000$ кадамдан кийин токтотулушу керек.
* _Pulibot_тун программасы аяктагандан кийин лабиринттеги бош клеткалар төмөнкүдөй түстө болушу керек:
   - $(0,0)$дөн $(H-1, W-1)$ге чейин эң кыска жолдун ар бир клеткасынын түсүн $1$ кылуу керек.
   - Бардык башка бош клеткалардын түсүн $0$ кылуу керек.
* _Pulibot_ өзүнүн программасын каалаган бош клеткада токтото алат.
  
Мисалы, төмөнкү сүрөттө $H = W = 6$ менен мүмкүн болгон лабиринт көрсөтүлгөн.
Баштапкы конфигурация сол жакта жана бош клеткалардын бир мүмкүн болгон түсү аяктагандан кийин оң жакта көрсөтүлгөн:


![Shortest path](robot-shortest-path.png "500")

## Ишке ашыруу деталдары

Сиз төмөнкү процедураны ишке ашырууңуз керек.

```
void program_pulibot()
```

* Бул процедура  _Pulibot_тун программасын түзүшүңүз керек. Бул программа $H$ жана $W$ бардык маанилери жана тапшырма чектөөлөрүнө жооп берген лабиринт үчүн туура иштеши керек.
* Бул процедура ар бир тест учуру үчүн бир жолу чакырылат.

Бул процедура _Pulibot_ программасын жасоо үчүн төмөнкү процедурага чакырууларды жасай алат:

```
void set_instruction(int[] S, int Z, char A)
```

* $S$: Абалдардын массивин сүрөттөгөн $5$ узундуктагы массив.
* $Z$: түстү билдирген терс эмес бүтүн сан.
* $A$: төмөнкүдөй _Pulibot_тун аракетин билдирген бир символ:
     - `H`: калуу;
     - `W`: батышка жылдыруу;
     - `S`: түштүккө жылдыруу;
     - `E`: чыгышка жылдыруу;
     - `N`: түндүккө жылдыруу;
     - `T`: программаны токтотуу.
* Бул процедураны чакыруу _Pulibot_ко $S$ абалдардын массивин тааныгандан кийин ал $(Z, A)$ көрсөтмөсүн аткарат

Бул процедураны бир эле $S$ абалдардын массиви менен бир нече жолу кайталоо `Output isn't correct`  деген жооп берет.

Ар бир мүмкүн болгон абалдардын массиви $S$ менен `set_instruction` деп чакыруу талап кылынбайт. Бирок, кийинчерээк _Pulibot_ инструкция коюлбаган абалдардын массивин тааныса, сизге `Output isn't correct` деген жооп берет.

`program_pulibot` аяктагандан кийин, грейдер бир же бир нече лабиринт боюнча _Pulibot_тун программасын чакырат.
Бул чакырыктар сиздин чыгарылышыңыздын убактысына *эсептелбейт*.
Грейдер адаптивдүү *эмес*, башкача айтканда лабиринттердин жыйындысы ар бир тест алдын ала аныкталган.

Эгер _Pulibot_ өзүнүн программасын токтотконго чейин робот мелдешинин эрежелеринин бирин бузса, сизге `Output isn't correct` деген жооп берет.

## Мисал

`program_pulibot` процедурасы `set_instruction`га төмөнкүдөй чакырууларды жасай алат:


Чакыраа                                         | Абалдардын массиви үчүн инструкция $S$
:-------------------------------------------:|:---------------------------------------:
`set_instruction([0, -2, -1, 0, -2], 1, E)`  | Клетканын түсүн $1$ кылып, чыгышка жылыңыз
`set_instruction([0, 1, -1, 0, -2], 1, E)`   | Клетканын түсүн $1$ кылып коюп, чыгышка жылыңыз
`set_instruction([0, 1, 0, -2, -2], 1, S)`   | Клетканын түсүн $1$ кылып коюп, түштүкө жылыңыз
`set_instruction([0, -1, -2, -2, 1], 1, T)`  | Клетканын түсүн $1$ кылып коюп, программаны токтотуңуз

$H=2$ жана $W=3$ болгон сценарийди карап көрөлү жана лабиринт төмөнкү сүрөттө көрсөтүлгөн.
![Example maze](robot-example-maze.png "200")

Бул лабиринт үчүн _Pulibot_тун программасы төрт чакыруудан турат. _Pulibot_ тааныган абалдардын массиви жана ал аткарган көрсөтмөлөр ирети менен жогоруда жасалган `set_instruction` төрт чалууга дал келет. Бул инструкциянын акыркысы программаны токтотот.

Төмөнкү сүрөттө төрт чакыруунун ар биринин алдындагы лабиринт жана аяктагандан кийинки акыркы түстөр көрсөтүлгөн.


![Example simulation](robot-example-steps.png "500")

Бирок, $4$ инструкциясынан турган бул программа башка жарактуу лабиринттерде эң кыска жолду таппай калышы мүмкүн экенин эске алыңыз.
Ошондуктан, эгер тапшырылса, ал `Output isn't correct` деген жооп берет.

## Чектөөлөр

$Z_{MAX} = 19$. Демек, _Pulibot_ 0дөн 19га чейинки түстөрдү колдоно алат.

_Pulibot_ту тест үчүн колдонулган ар бир лабиринт үчүн:
* $2 \le H, W \le 15$
* $(0,0)$ клеткасынан $(H-1, W-1)$ клеткасына чейин жок дегенде бир жол бар.
* 

## Кошумча тапшырмалар

1. (6 упай) Лабиринтте эч кандай тоскоолдук клеткасы жок.
1. (10 упай) $H = 2$
1. (18 упай) Ар бир жуп бош клетканын ортосунда так бир жол бар.
1. (20 упай) $(0,0)$ клеткасынан $(H-1, W-1)$ клеткасына чейинки ар бир эң кыска жолдун узундугу $H + W - 2$.
1. (46 упай) Кошумча чектөөлөр жок.


Эгерде тест учурларынын кайсы биринде ` set_instruction ` процедурасына же _Pulibot_ программасына анын аткарылышына карата чакыруулар Ишке ашыруунун чоо-жайында сүрөттөлгөн чектөөлөргө туура келбесе, ал кошумча тапшырма үчүн чыгарылышыңыздын упайы $0$ болот.

Ар бир кошумча тапшырмада сиз дээрлик туура болгон боё чыгаруу менен жарым-жартылай упай ала аласыз.

Расмий түрдө:
* Эгерде бош уячалардын акыркы боёгу Робот мелдешинин эрежелерине жооп берсе, тесттик иштин жыйынтыгы **толук** болуп саналат.
* Тесттердин чечими **жарым-жартылай** болуп саналат, эгерде акыркы боё төмөнкүдөй болсо:
   - $(0,0)$дөн $(H-1, W-1)$ге чейин эң кыска жол бар, ал үчүн жолго киргизилген ар бир клетканын түсү $1$.
   - Тордо $1$ түсү бар башка бош клетка жок.
   - Тордогу кээ бир бош клетканын түсү $0$ жана $1$ эмес.
   

Эгерде сиздин чыгарылышыңыз толук же жарым-жартылай болбосо, тиешелүү тест иши боюнча упайыңыз $0$ болот.

1-4-кошумча тапшырмаларда толук упай үчүн  100% , ал эми тесттик иштин жарым-жартылай чыгарылышы үчүн упай анын кошумча тапшырмасы үчүн упайдын 50% түзөт.

5-кошумча тапшырмада сиздин упайыңыз _Pulibot_ программасында колдонулган түстөрдүн санына жараша болот.
Тагыраак айтканда, $Z^\star$ менен `set_instruction` үчүн жасалган бардык чакыруулардагы $Z$ максималдуу маанисин белгилеңиз.
Тесттин упайы төмөнкү таблица боюнча эсептелет:



| Шарт              | Упай (толук)      | Упай (жарым-жартылай)      |
|:-----------------------:|:---------------------:|:---------------------:|
| $11 \le Z^\star \le 19$ | $20 + (19 - Z^\star)$ | $12 + (19 - Z^\star)$ |
| $Z^\star = 10$          | $31$                  | $23$                  |
| $Z^\star = 9$           | $34$                  | $26$                  |
| $Z^\star = 8$           | $38$                  | $29$                  |
| $Z^\star = 7$           | $42$                  | $32$                  |
| $Z^\star \le 6$         | $46$                  | $36$                  |

Ар бир кошумча тапшырманын упайы – бул кошумча тапшырмадагы тесттик иштердин минималдуу упайы.

## Үлгү Грейдер

Үлгү грейдер киргизүүнү төмөнкү форматта окуйт:
* $1$ - сап: $H \; W$
* $(2 + r)$ - сап  ($0 \le r \lt H$): $m[r][0] \; m[r][1] \; \ldots \; m[r][W-1]$

Бул жерде, $m$ лабиринттин чек арадагы эмес клеткаларын сүрөттөгөн $W$ бүтүн сандардын $H$ массивдеринин массиви.
$m[r][c] = 0$, эгерде $(r, c)$ клеткасы бош клетка болсо, $m[r][c] = 1$, $(r, c)$ клеткасы тоскоолдук клеткасы болсо.


<!-- IMPORTANT NOTE TO TRANSLATORS: THE FOLLOWING MESSAGES (IN BACKTICKS) SHOULD NOT BE TRANSLATED -->

Үлгү грейдер биринчи `program_pulibot()` чакырат.
Эгерде үлгүдөгү грейдер протоколдун бузулушун аныктаса
`Protocol Violation: <MSG>`  деп чыгарат жана токтотулат, мында `<MSG>` төмөнкү каталардын бири болуп саналат:

* `Invalid array`: $-2 \le S[i] \le Z_{MAX}$ кээ бир $i$ үчүн туура келбейт же $S$ узундугу $5$ эмес.
* `Invalid color`: $0 \le Z \le Z_{MAX}$ туура келбейт.
*  `Invalid action`: $A$ белгиси `H`, `W`, `S`, `E`, `N` же `T` символдорунун бири эмес.
* `Same state array`: `set_instruction`  бир эле $S$ массиви менен кеминде эки жолу чакырылган.

Болбосо, `program_pulibot` аяктаганда, үлгү грейдер _Pulibot_тун программасын киргизүү менен сүрөттөлгөн лабиринтте аткарат.

Үлгү грейдер эки жыйынтык чыгарат.

Биринчиси, үлгү грейдер жумушчу каталогдогу `robot.bin` файлына _Pulibot_тун аракеттеринин журналын жазат.
Бул файл кийинки бөлүмдө сүрөттөлгөн визуалдаштыруу куралынын кириши катары кызмат кылат.

Экинчиси, _Pulibot_ программасы ийгиликтүү аяктабаса, үлгү грейдер төмөнкү ката билдирүүлөрүнүн бирин басып чыгарат:

* `Unexpected state`: : _Pulibot_ `set_instruction` чакырылбаган абалдардын массивин тааныды.
* `Invalid move`: аракеттин натыйжасында _Pulibot_ бош эмес клеткага жылды.
* `Too many steps`: _Pulibot_ программасын токтотпостон $500\,000$ кадамдарды жасады.

Болбосо, _Pulibot_ программасы аяктагандан кийин $e[r][c]$ $(r, c)$ уячасынын абалы болсун.
Үлгү грейдер $H$ сызыктарын төмөнкү форматта  чыгарат:
* Сап $1 + r$ ($0 \le r \lt H$): $e[r][0] \; e[r][1] \; \ldots \; e[r][W-1]$

## Дисплей куралы

Бул тапшырма үчүн тиркеме топтому `display.py` деп аталган файлды камтыйт.
Чакырылганда, бул Python скрипти үлгү грейдердин киргизүүсү менен сүрөттөлгөн лабиринтте _Pulibot_тун аракеттерин көрсөтөт.
Бул үчүн `robot.bin` бинардык файлы жумушчу каталогдо болушу керек.

Скриптти чакыруу үчүн, төмөнкү буйрукту аткарыңыз.
```
python3 display.py
```

Жөнөкөй графикалык интерфейс пайда болот. Негизги өзгөчөлүктөрү төмөнкүлөр болуп саналат:

* Толук лабиринттин абалын байкай аласыз. Пулиботтун учурдагы жайгашкан жери тик бурчтук менен белгиленген.
* Сиз жебе баскычтарын басуу же алардын hotkeys баскычтарын басып _Pulibot_ кадамдарын карап чыга аласыз. Ошондой эле белгилүү бир кадамга секире аласыз.
* _Pulibot_тун программасында алдыдагы кадам ылдыйда көрсөтүлгөн.
Ал учурдагы абалдардын массиви жана ал аткара турган инструкцияны көрсөтөт.
Акыркы кадамдан кийин, ал грейдердин ката билдирүүлөрүнүн бирин көрсөтөт, же программа ийгиликтүү аяктаса `Terminated`.
* Түстү билдирген ар бир санга визуалдык фон түсүн, ошондой эле дисплей текстин дайындай аласыз. Дисплей тексти бул түстөгү ар бир уячада пайда боло турган кыска сап. Фондук түстөрдү дайындап, тексттерди төмөнкү жолдор менен көрсөтсөңүз болот:
   -  `Colors`  баскычын баскандан кийин аларды диалог терезесинде орнотуңуз.
   - `colors.txt` файлынын мазмунун түзөтүңүз.
* `robot.bin` кайра жүктөө үчүн, `Reload` баскычын колдонуңуз. Бул `robot.bin` мазмуну өзгөргөн болсо, пайдалуу.
